#ifndef TERMCONTROL_H
#define TERMCONTROL_H
#include "mbed.h"
#include <string>
//0x1B is escape
#define FLASH_STRING const char * const
class TermControl
{
    public:
    TermControl()
    {
    
    }
    TermControl(Stream* term)
    {
        Term=term;
    }
    const char Escape='\x1B';
    FLASH_STRING ReportVT100="\x1B[?1;0c";
    void SetTerminal(Stream* term)
    {
        Term=term;
    }
    Stream* GetTerminal()
    {
        return Term;
    }
    //terminal control
    void Reset()
    {
        Print("\x1Bc");
    }
    void Clear()
    {
        Term->printf("\x1B[2J");
    }
    void PrintAt(int x, int y, string s)
    {
        SaveCursor();
        ResetCursor();
        SetCursor(x,y);
        Print(s);
        RestoreCursor();
    }
    //todo void PrintfAt(int x, int y, string f, ...);
    char GetChar()
    {
        return Term->getc();
    }
    void SetCursor(int x, int y)
    {
        Term->printf("\x1B[%i;%iH",y,x);
    }
    void ResetCursor()
    {
        Term->printf("\x1B[H");
    }
    void SaveCursor()
    {
        Term->printf("\x1B[s");
    }
    void RestoreCursor()
    {
        Term->printf("\x1B[u");
    }
    void EnableScrolling(int begin, int end) //begin and end are row numbers
    {
        Term->printf("\x1B[%i;%ir",begin,end);
    } 
    void ScrollDown()
    {
        Term->printf("\x1BD");
    }
    void ScrollUp()
    {
        Term->printf("\x1BM");
    }
    void EraseLine()
    {
        Term->printf("\x1B[2K");
    }
    void Print(string s)
    {
        Term->puts(s.c_str());
    }
    
    
    private:
    Stream *Term;
};
    



#endif